#include <bits/stdc++.h>

using namespace std;
#define int long long
deque<int> dq;
vector<int> d;

void add(int id) {
    int val = d[id] - id;
    while (dq.size() > 0 && d[dq.back()] - dq.back() <= val) {
        dq.pop_back();
    }
    dq.push_back(id);
}

int get() {
    int id = dq.front();
    return d[id] - id;
}

void del(int id) {
    if (dq.size() == 0)return;
    if (dq.front() == id) {
        dq.pop_front();
    }
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    d.resize(2 * n);
    int f;
    cin >> f;
    if (f == 1) {
        for (int i = 0; i < n; ++i) {
            cin >> d[i];
        }
    } else {
        int m, x, y, z;
        cin >> m >> x >> y >> z;
        vector<int> c(m);
        for (int i = 0; i < m; ++i) {
            cin >> c[i];
            d[i] = c[i];
        }
        for (int i = m; i < n; ++i) {
            d[i] = ((x * d[i - 2] + y * d[i - 1] + z) % ((int) 1e9)) + 1;
        }
    }
    for (int i = n; i < 2 * n; ++i) {
        d[i] = d[i - n];
    }
    for (int i = 0; i < n; ++i) {
        add(i);
    }
    int ans = 1e18;
    int beg = -1;
    for (int i = 0; i < n; ++i) {
        int res = get() + i;
        if (ans > res) {
            ans = res;
            beg = i;
        }
        del(i);
        add(i + n);
    }
    cout << ans << " " << beg + 1;
}
