#include <bits/stdc++.h>

using namespace std;
#define int long long
int n;

int get_mx_pal(vector<int> a) {
    if (a.size() == 0)return 0;
    n = a.size();
    vector<int> d1(n);
    vector<int> d2(n);
    int ans = 1;
    int id = 0;
    d1[0] = 1;
    for (int i = 1; i < n; ++i) {
        if (id + d1[id] - 1 >= i) {
            int y = id - d1[id] + 1 + (id + d1[id] - 1 - i);
            d1[i] = min((id + d1[id] - 1 - i), d1[y]);
        } else {
            d1[i] = 1;
        }
        while (d1[i] + 1 <= min(i + 1, n - i) && a[i - d1[i]] == a[i + d1[i]]) {
            d1[i]++;
        }
        if (id + d1[id] < i + d1[i]) {
            id = i;
        }
        ans = max(ans, d1[i] * 2 - 1);
    }
    d2[1] = 0;
    id = 1;
    for (int i = 2; i < n; ++i) {
        if (id + d2[id] - 1 >= i) {
            int y = id - d2[id] + (id + d2[id] - 1 - i + 1);
            d2[i] = min((id + d2[id] - 1 - i + 1), d2[y]);
        } else {
            d2[i] = 0;
        }
        while (d2[i] + 1 <= min(i, n - i) && a[i - d2[i] - 1] == a[i + d2[i]]) {
            d2[i]++;
        }
        if (id + d2[id] < i + d2[i]) {
            id = i;
        }
        ans = max(ans, d2[i] * 2);
    }
    return ans;
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif

    int N, M;
    cin >> N >> M;
    vector<int> a(N);
    vector<int> b(M);
    for (int i = 0; i < N; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < M; ++i) {
        cin >> b[i];
    }
    int ans = 0;
    for (int i = 0; i <= N; ++i) {
        vector<int> s(min(M, N - i));
        for (int j = 0; j < s.size(); ++j) {
            s[j] = b[j] + a[j + i];
        }
        ans = max(get_mx_pal(s), ans);
    }
    for (int i = 0; i <= M; ++i) {
        vector<int> s(min(M - i, N));
        for (int j = 0; j < s.size(); ++j) {
            s[j] = b[j + i] + a[j];
        }
        ans = max(ans, get_mx_pal(s));
    }
    cout << ans << "\n";
}