#include <bits/stdc++.h>

using namespace std;
#define int long long
vector<int> a;
vector<int> b;
int n;
vector<pair<int, int>> c;
vector<pair<int, int>> answer;

bool comp(pair<int, int> A, pair<int, int> B) {
    return A.first * B.second < A.second * B.first;
}

struct f {
    int x, y;
    int id;

    f(int xx, int yy, int ind) {
        x = xx;
        y = yy;
        id = ind;
    }
};

bool operator<(f a1, f a2) {
    return comp({a1.x, a1.y}, {a2.x, a2.y});
}

vector<f> st;

f get_mn() {
    f ans = st[0];
    for (int i = 0; i < st.size(); ++i) {
        if (st[i] < ans) {
            ans = st[i];
        }
    }
    return ans;
}

void del(f a) {
    vector<f> n_s;
    for (int i = 0; i < st.size(); ++i) {
        if (st[i].id != a.id) {
            n_s.push_back(st[i]);
        }
    }
    st = n_s;
}

void add(f a) {
    st.push_back(a);
}

pair<int, int> solve() {
    st.clear();
    vector<int> ps(n);
    for (int i = 0; i < n; ++i) {
        add(f(a[i], b[ps[i]], i));
    }
    pair<int, int> last;
    int now = -1;
    for (int i = 0; i < c.size(); ++i) {
        while (now != c[i].first - 1) {
            auto it = get_mn();
            del(it);
            ps[it.id]++;
            if (ps[it.id] != n)
                add(f(a[it.id], b[ps[it.id]], it.id));
            last = {it.x, it.y};
            now++;
        }
        answer[c[i].second] = last;
    }
    return last;
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif

    int q;
    cin >> n >> q;
    a.resize(n);
    b.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    sort(a.begin(), a.end());
    sort(b.rbegin(), b.rend());
    c.resize(q);
    answer.resize(q);
    for (int i = 0; i < q; ++i) {
        cin >> c[i].first;
        c[i].second = i;
    }
    sort(c.begin(), c.end());
    solve();
    for (int i = 0; i < q; ++i) {
        auto ans = answer[i];
        int g = __gcd(ans.first, ans.second);
        cout << ans.first / g << " " << ans.second / g << "\n";
    }
}
