#include <bits/stdc++.h>

using namespace std;
#define int long long
vector<int> a;
vector<int> b;
int n;
vector<pair<int, int>> c;
vector<pair<int, int>> answer;

bool comp(pair<int, int> A, pair<int, int> B) {
    return A.first * B.second < A.second * B.first;
}

multiset<pair<double, pair<int, pair<int, int>>>> st;

pair<int, pair<int, int>> get_mn() {
    return st.begin()->second;
}

void del() {
    st.erase(st.begin());
}

void add(pair<int, int> a, int id) {
    st.insert({(double) a.first / a.second, {id, a}});
}

pair<int, int> solve() {
    st.clear();
    vector<int> ps(n);
    for (int i = 0; i < n; ++i) {
        add({a[i], b[ps[i]]}, i);
    }
    pair<int, int> last;
    int now = -1;
    for (int i = 0; i < c.size(); ++i) {
        while (now != c[i].first - 1) {
            auto it = get_mn();
            del();
            ps[it.first]++;
            if (ps[it.first] != n)
                add({a[it.first], b[ps[it.first]]}, it.first);
            last = it.second;
            now++;
        }
        answer[c[i].second] = last;
    }
    return last;
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif

    int q;
    cin >> n >> q;
    a.resize(n);
    b.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    sort(a.begin(), a.end());
    sort(b.rbegin(), b.rend());
    c.resize(q);
    answer.resize(q);
    for (int i = 0; i < q; ++i) {
        cin >> c[i].first;
        c[i].second = i;
    }
    sort(c.begin(), c.end());
    solve();
    for (int i = 0; i < q; ++i) {
        auto ans = answer[i];
        int g = __gcd(ans.first, ans.second);
        cout << ans.first / g << " " << ans.second / g << "\n";
    }
}