#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 2e5;
int maxpref[maxn + 1];
int maxsuf[maxn + 1];
int sum[maxn + 1];
int a[maxn];
int answer[maxn];
int pref[maxn + 1];

int getmn(int l, int r) {
    int mn = 1e18;
    for (int i = l; i <= r; ++i) {
        mn = min(mn, pref[i]);
    }
    return mn;
}

void calc(int l, int r) {
    maxpref[r] = 0;
    maxsuf[r] = 0;
    int pref = 0;
    for (int i = l; i < r; ++i) {
        pref += a[i];
        maxpref[r] = max(maxpref[r], pref);
    }
    sum[r] = pref;
    int suf = 0;
    for (int i = r - 1; i >= l; --i) {
        suf += a[i];
        maxsuf[i] = max(maxsuf[i], suf);
    }
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    set<int> blocks;
    blocks.insert(n);
    calc(0, n);
    vector<pair<int, int>> el;
    for (int i = 0; i < n; ++i) {
        el.push_back({a[i], i});
    }
    sort(el.begin(), el.end());
    int ans = -1e18;

    if (k == 0) {
        pref[0] = 0;
        for (int i = 1; i < n + 1; ++i) {
            pref[i] = pref[i - 1] + a[i - 1];
        }
        set<int> st;
        for (int i = 0; i < n; ++i) {
            st.insert(pref[i]);
            if (st.size() > 0) {
                ans = max(ans, pref[i + 1] - *st.begin());
            }
        }
        cout << ans << "\n";
        exit(0);
    }
    if (k == 1) {
        pref[0] = 0;
        for (int i = 1; i < n + 1; ++i) {
            pref[i] = pref[i - 1] + a[i - 1];
        }
        vector<int> st;
        multiset<int> values;
        for (int i = 0; i < n; ++i) {
            while (st.size() > 0 && a[st.back()] <= a[i]) {
                int el = st.back();
                st.pop_back();
                int last = 0;
                if (st.size() > 0)last = st.back() + 1;
                values.erase(values.find(getmn(last, el) + a[el]));
            }
            int last = 0;
            if (st.size() > 0)last = st.back() + 1;
            st.push_back(i);
            int add = getmn(last, i) + a[i];
            values.insert(add);
            if (values.size() > 0)
                ans = max(ans, pref[i + 1] - *values.begin());

        }
        cout << ans << "\n";
        exit(0);
    }
    multiset<int> values;
    for (int i = 0; i < n; ++i) {
        answer[i] = -1e18;
        values.insert(answer[i]);
    }
    for (int i = 0; i < el.size(); ++i) {
        int ps = el[i].second;
        auto it = blocks.upper_bound(ps);
        int l = 0;
        int r = *it;
        if (it != blocks.begin()) {
            auto it2 = it;
            it2--;
            l = *it2 + 1;
        }
        blocks.erase(it);
        calc(l, ps);
        calc(ps + 1, r);
        vector<int> first;
        vector<int> sec;
        blocks.insert(ps);
        blocks.insert(r);
        it = blocks.find(ps);
        auto it2 = blocks.find(r);
        int cnt = k;
        first.push_back(*it);
        cnt--;
        while (cnt > 0 && it != blocks.begin()) {
            it--;
            first.push_back(*it);
            cnt--;
        }
        cnt = k;
        while (cnt > 0 && it2 != blocks.end()) {
            sec.push_back(*it2);
            it2++;
            cnt--;
        }
        int sum_f[first.size() + 1];
        sum_f[0] = 0;
        int sum_s[sec.size() + 1];
        sum_s[0] = 0;
        for (int j = 0; j < first.size(); ++j) {
            sum_f[j + 1] = sum_f[j] + sum[first[j]];
        }
        for (int j = 0; j < sec.size(); ++j) {
            sum_s[j + 1] = sum_s[j] + sum[sec[j]];
        }
        if (sec.size() >= k) {
            values.erase(values.find(answer[sec[0]]));
            answer[sec[0]] = maxpref[sec[0]] + sum_s[k - 1] - sum_s[1] + maxsuf[sec[k - 1]];
            values.insert(answer[sec[0]]);
        }
        if (first.size() >= k) {
            values.erase(values.find(answer[first[k - 1]]));
            answer[first[k - 1]] = maxpref[first[k - 1]] + sum_f[k - 1] - sum_f[1] + maxsuf[first[0]];
            values.insert(answer[first[k - 1]]);
        }
        for (int j = 0; j < min(k - 1, (int) first.size()); ++j) {
            int left = k - (j + 1);
            values.erase(values.find(answer[first[j]]));
            if (sec.size() >= left) {
                answer[first[j]] = maxpref[first[j]] + sum_f[j] + sum_s[left - 1] + maxsuf[sec[left - 1]];
            } else {
                answer[first[j]] = -1e18;
            }
            values.insert(answer[first[j]]);
        }
        int res = *(--values.end());
        ans = max(ans, res);
    }
    cout << ans << "\n";
}